'' +--------------------------------------------------------------------------+
'' | ......OS   An Operating System for the Propeller Chip                    |
'' +--------------------------------------------------------------------------+
'' |                     HUB DEFINITIONS                                      |
'' +--------------------------------------------------------------------------+
'' |  License            MIT License                                          |
'' +--------------------------------------------------------------------------+
'' RR20120304   Proposal of hub layout
con

'Hub Rendezvous locations...
' _HubFree: stores the total of hub available (i.e. $7000 means $0000-$6FFF is available)
'           the top byte us set to $5A if its valid
  _HubFree      = $8000         - 1 * 4    'stores total hub avalable (see note above)
  _StdIn        = _HubFree      - 1 * 4    'standard input  rendezvous
  _StdOut       = _StdIn        - 1 * 4    'standard output rendezvous
  _AuxIn        = _StdOut       - 1 * 4    'auxilary input  rendezvous
  _AuxOut       = _AuxIn        - 1 * 4    'auxilary output rendezvous
  _User1        = _AuxOut       - 1 * 4    'user 1          rendezvous
  _User2        = _User1        - 1 * 4    'user 2          rendezvous
  _User3        = _User2        - 1 * 4    'user 3          rendezvous
'  ^^^            $7FE0

' _undefined    = $7FA0       ' - 64
  _inBuf        = $7F90       ' - 16       'StdIn  buffer
  _OutBuf       = $7F80       ' - 16       'StdOut buffer
  _strBuf       = $7F00       ' - 128      'general purpose string buffer

  _OS           = $7E00       ' ???        'Possible resident spin OS stub             

  _SDbuffer     = $7C00       ' - 512      'buffer                 /
  _Interpreter  = $7400       ' - 2048     ' \ Cluso's Interpreter
  _I_Vector     = $7000       ' - 1024     ' /

  _SetHubFree   = $7000 | ($5A << 24)      '$7000-$7FFF is used by the OS


  
PUB dummy